#ifndef SCENEGRAPH_H
#define SCENEGRAPH_H

#include <QList>
#include <rigidbodytransformation.h>
#include <box.h>

class MyGLWidget;

class SceneGraph
{
public:
    SceneGraph();

    RigidBodyTransformation* addBox(int tesselation);
    void drawAll();
    void registerView(MyGLWidget* view);
    void notifyViews();

    void addTranslation(RigidBodyTransformation* r, QVector3D diff);
    void addRotation(RigidBodyTransformation* r, QQuaternion diff);
private:
    int idCounter;

    int boxIndex;
    QString nextBoxName;
    QList<RigidBodyTransformation*> nodes;
    QList<MyGLWidget*> views;


};

#endif // SCENEGRAPH_H
